{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.MediaLive.Types.HlsSegmentationMode
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.MediaLive.Types.HlsSegmentationMode
  ( HlsSegmentationMode
      ( ..,
        HlsSegmentationMode_USE_INPUT_SEGMENTATION,
        HlsSegmentationMode_USE_SEGMENT_DURATION
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

-- | Hls Segmentation Mode
newtype HlsSegmentationMode = HlsSegmentationMode'
  { fromHlsSegmentationMode ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern HlsSegmentationMode_USE_INPUT_SEGMENTATION :: HlsSegmentationMode
pattern HlsSegmentationMode_USE_INPUT_SEGMENTATION = HlsSegmentationMode' "USE_INPUT_SEGMENTATION"

pattern HlsSegmentationMode_USE_SEGMENT_DURATION :: HlsSegmentationMode
pattern HlsSegmentationMode_USE_SEGMENT_DURATION = HlsSegmentationMode' "USE_SEGMENT_DURATION"

{-# COMPLETE
  HlsSegmentationMode_USE_INPUT_SEGMENTATION,
  HlsSegmentationMode_USE_SEGMENT_DURATION,
  HlsSegmentationMode'
  #-}
